#include "Database.h"


Database::Database(string F) {
  static char *p, tbuf[250];
  FILE *f = fopen(F.c_str(), "r");
  int state = 0;
  Table *T;
  File = F;
  while(fgets(tbuf, sizeof(tbuf), f)) {
    if( (p = strchr(tbuf, '\n')) ) *p = 0; else continue;
    while( (p=strchr(tbuf, '\t')) ) memmove(p, p+1, strlen(p));
    while( *tbuf == ' ' || *tbuf == '\t' ) memmove(tbuf, tbuf+1, strlen(tbuf));
    if( *tbuf == ';' || *tbuf == '#' || tbuf == '\0' ) continue;
    if (state) {
      if( !(p = strchr(tbuf, ':')) ) continue;
      *p++ = 0;
      T->Set ( trim(tbuf), trim(p) ); 
      //printf("Set \"%s\" : \"%s\"\n", trim(tbuf).c_str(), trim(p).c_str());
    } else {
      p = tbuf + strlen(tbuf);
      while( *p == ' ' || *p == '\t' || *p == '\n' ) {
        *p-- = 0;
        if( p == tbuf ) continue;;
        }
      while( (p=strstr(tbuf, "  ")) )
             memmove( p, p+1, strlen(p) );
      if(!strncasecmp(tbuf, "table ", 6)) { 
        state =1;
        T = AddTable (tbuf+6);
        //printf("%s: Found table : %s\n", F.c_str(),tbuf);
        } else break; 
    }  
  }
  fclose(f);
}
/*
Database::Database (string F)
{
  ifstream *DbFile = new ifstream (F.c_str ());
  string Buffer, Line;
  Table *T;

  File = F;

  while (*DbFile)
    {
      *DbFile >> Buffer;
      if (Buffer == "table")
	{

	  getline (*DbFile, Line);
	  Line = Line.substr (1, Line.size () - 1);
	  T = AddTable (Line);

	  while (*DbFile)
	    {
	      *DbFile >> Buffer;

	      if (Buffer == "end")
		break;
	      if (Buffer[Buffer.size () - 1] == ':')
		{
		  Buffer = Buffer.substr (0, Buffer.size () - 1);
		  getline (*DbFile, Line);
		  Line = Line.substr (1, Line.size () - 1);
		  T->Set ( trim(Buffer), trim(Line) );
		}
	    }

	}
    }
    //delete ( DbFile );
    DbFile->close();

}
*/

Table *
Database::AddTable (string Title)
{
  Table *T = new Table (Title);
  Tables.push_back (T);
  return T;
}


Table *
Database::Query (string Title)
{
  for (int i = 0; i < Tables.size (); i++)
    if (Tables[i]->Title == Title)
      return Tables[i];

  return NULL;
}


void
Database::Write ()
{
  //ofstream *DbFile = new ofstream (File.c_str ());
  printf("File: %s\n", File.c_str ());
  FILE *f = fopen(File.c_str (), "w+");
  if(!f) return  perror("Error saving config");
  for (int i = 0; i < Tables.size (); i++)
    {
      //(*DbFile) << "table " << Tables[i]->Title << endl;
      fprintf(f, "table %s\n", Tables[i]->Title.c_str() );
      for (int a = 0; a < Tables[i]->Label.size (); a++)
	{
	  //(*DbFile) << "  " << Tables[i]->Label[a] << ": " << Tables[i]->
	  //  Value[a] << endl;
          fprintf(f, " %s: %s\n", Tables[i]->Label[a].c_str(), Tables[i]->Value[a].c_str());
	}
      //(*DbFile) << "end\n\n";
      fprintf(f, "end\n");
    }
   
  //DbFile->close ();
  fclose(f);
}

// trim a string's leading and trailing spaces/tabs
string  Database::trim ( string source ) {
int  n = source.find_first_not_of(" \t");
if (n<0) return "";
int m =  source.find_last_not_of(" \t");
return source.substr(n, m-n+1);
}

Table::Table (string T)
{
  Title = T;
}


void
Table::Set (string L, string V)
{
  if (Query (L) == "")
    {
      Label.push_back (L);
      Value.push_back (V);
    }
  else
    {
      for (int i = 0; i < Label.size (); i++)
	if (Label[i] == L)
	  Value[i] = V;
    }
}


string
Table::Query (string L)
{
  for (int i = 0; i < Label.size (); i++)
    if (Label[i] == L)
      return Value[i];

  return "";
}
