#ifndef __desk_h__
#define __desk_h__

#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <Imlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#ifdef FREEBSD
#include <sys/param.h>
#include <sys/ucred.h>
#include <sys/mount.h>
#endif
#ifdef LINUX
#include <mntent.h>
#endif
#include <stdlib.h>

#include "Database.h"
#include "empty.xpm"
#include "unknown.xpm"

class Icon;

int makeBooleanFromStr(char *str, int dflt);
#define MTABFILE "/etc/mtab"
struct BackgroundJobStruct
{
  XtWorkProc procPtr;
  XtPointer xtPtr;
};
class Desk
{
private:
  XtAppContext app_context;
  Widget toplevel;
  ImlibData *Data;
  //XFontStruct *fontInfo;
  //Font font;
  XColor FontFore, FontBack;
  int CaptionBack, CaptionBorder,
       snapX, snapY;
    vector < Icon * >Icons;
  int ClickInterval;
  //mounts info
  time_t last_time;
  int changed;
    vector < char* > mounts;
  struct stat buf;
  time_t JobTime;
    vector < struct BackgroundJobStruct *>Jobs;
  Boolean MountCheck (void);
  Pixmap UnknownPixmap, UnknownMask, EmptyPixmap, EmptyMask;
  int UPixmapWidth, UPixmapHeight, EPixmapWidth, EPixmapHeight;
  int IconWidth, IconHeight, IconFixed;
public:
   XFontSet fontset;
    Desk (int *argc, char **argv);
   ~Desk ();
  void DeleteIcon(Icon *I); 
  int CreateIcon(char *cfgFile);
  inline XtAppContext GetAppContext (void)
  {
    return app_context;
  }
  inline void MainLoop (void)
  {
    XtAppMainLoop (app_context);
  };
  inline ImlibData *Im (void)
  {
    return Data;
  };
  inline Display *Disp (void)
  {
    return XtDisplay (toplevel);
  };
  inline Widget Wget (void)
  {
    return toplevel;
  };
  //inline XColor *fntFore(void) { return &FontFore; };
  //inline XColor *fntBack(void) { return &FontBack; };
  inline unsigned long fntFore (void)
  {
    return FontFore.pixel;
  }
  inline unsigned long fntBack (void)
  {
    return FontBack.pixel;
  }
  inline Screen *Scr (void)
  {
    return XtScreen (toplevel);
  };
  inline Window Root (void)
  {
    return DefaultRootWindow (XtDisplay (toplevel));
  };
  inline int getClickInterval (void)
  {
    return ClickInterval;
  };
  void LoadOptions (void);
  void LoadIcons (void);
  void setCheckMountProc (Icon * I);
  static void procIsMounted (Icon * I);
  Boolean Desk::isMounted (char *mnt);
  static Boolean procExecJobs (XtPointer D);
  Boolean ExecJobs (void);
  inline Pixmap getUPixmap(void){return UnknownPixmap;};
  inline Pixmap getUMask(void){return UnknownMask;};
  inline Pixmap getEPixmap(void){return EmptyPixmap;};
  inline Pixmap getEMask(void){return EmptyMask;};
  inline int getUPixmapWidth(void){return UPixmapWidth;}; 
  inline int getUPixmapHeight(void){return UPixmapHeight;}; 
  inline int getEPixmapWidth(void){return EPixmapWidth;}; 
  inline int getEPixmapHeight(void){return EPixmapHeight;};
  inline int getIconWidth(void) { return IconWidth; };    
  inline int getIconHeight(void) { return IconHeight; };    
  inline int getIconFixed(void) { return IconFixed; };    
  inline int getCaptionBack(void) { return CaptionBack; };
  inline int getCaptionBorder(void) { return CaptionBorder; };
  inline int getsnapX (void) { return snapX; };
  inline int getsnapY (void) { return snapY; };
  void Desk::LowerIcons(Icon *I);
};

#endif
