#include "icon.h"
#include <stdlib.h>
#include "button.xpm"
static Pixmap button = 0;
Icon::Icon (Desk * Dsk, char *F, Table * T)
{
  ConfigFile = strdup (F);
  Command = strdup ((char *) T->Query ("Command").c_str ());
  Caption = strdup ((char *) T->Query ("Caption").c_str ());
  CaptionAlign = 
    (strncasecmp( (char *) T->Query ("CaptionAlign").c_str (), "l", 1 ))?
    'c' : 'l';
  this->X = atoi ((char *) T->Query ("X").c_str ());
  this->Y = atoi ((char *) T->Query ("Y").c_str ());;
/*
  Fixed = (char *) T->Query ("Fixed").c_str ();
  if( !Fixed || strlen(Fixed) == 0 ) iFixed = -1;
  else
   if( !strcmp(Fixed, "1") || !strcasecmp(Fixed, "y") || 
       !strcasecmp(Fixed, "yes") || !strcasecmp(Fixed, "true") )
       iFixed = 1;
       else {
       iFixed = 0;
       //T->Set("Fixed", "False");
       }
  iFixed = (iFixed > 0 || (iFixed != 0 && ( Dsk->getIconFixed() > 0 )) ) ? 1 : 0;
*/
  iFixed = makeBooleanFromStr( (char *) T->Query ("Fixed").c_str (),
                               Dsk->getIconFixed() );
  iFixed = (iFixed==0)?0:1;
  CaptionBack = makeBooleanFromStr( 
                  (char *) T->Query ("CaptionBackground").c_str (),
                  Dsk->getCaptionBack() 
                );
  CaptionBack = (CaptionBack <=0) ? 0 : 1;
  CaptionBorder = makeBooleanFromStr( 
                  (char *) T->Query ("CaptionBorder").c_str (),
                  Dsk->getCaptionBorder() 
                );
  CaptionBorder = (CaptionBack>0 && CaptionBorder!=0) ? 1: 0;
  BtnTime = BtnX = BtnY = 0;
  WinWidth = WinHeight = 0;
  tpixmap = tmask = 0;
  Draging = False;
  P = NULL;
  D = Dsk;
#ifdef PRNDEBUG  
  printf("== Creating icon %s ==>\n", (Caption)?(Caption):(ConfigFile));
#endif
  CreateImages(T);
#ifdef PRNDEBUG  
  printf("images created\n");
#endif
  // 
  // Create icon window
  // 
  CreateIconWindow();
#ifdef PRNDEBUG  
  printf("icon window created\n");
  // create icon caption window 
#endif
  CreateCaptionImage();
#ifdef PRNDEBUG  
  printf("Caption image created\n");
#endif
  CreateCaptionWindow();
#ifdef PRNDEBUG  
  printf("Caption window created\n");
#endif
  OverrideRedirect();
  // 
  // Set bindings
  SetEventHandlers();
  CreateMenu(T);
  XtMapWidget (Win);
  XLowerWindow (dtDisplay, XtWindow (Win));
  XtMapWidget (Text);
  XLowerWindow (dtDisplay, XtWindow (Text));
#ifdef PRNDEBUG  
  printf ("==> Icon %s created <=\n", Caption);
#endif
}
// we are being told to drop ourselves down in the window stack
void Icon::lowerme (void) {
          XLowerWindow (dtDisplay, XtWindow(Win));
          XLowerWindow (dtDisplay, XtWindow(Text));
}

// we are being told to raise ourselves to the top of the window stack
void Icon::raiseme (void) {
          XRaiseWindow (dtDisplay, XtWindow(Text));
          XRaiseWindow (dtDisplay, XtWindow(Win));
}

void
Icon::procBtnDown (Widget w, XtPointer client_data,
		   XEvent * event, Boolean * b)
{
  ((Icon *) client_data)->BtnDown(event);
}
void
Icon::BtnDown ( XEvent * event )
{
  if (event->xbutton.button == Button1)
    {
      if (event->xbutton.time - BtnTime <= dClick)
	{
	  //printf ("Execute program\n");
	  Execute ();
	  BtnTime = 0;
          lowerme();
          D->LowerIcons(this);
	}
      else
       {
        raiseme();
	BtnTime = event->xbutton.time;
	if (!iFixed)
           Draging = True;
	BtnX = event->xbutton.x_root;
	BtnY = event->xbutton.y_root;
	}
    }
	  return;
}
void
Icon::procBtnUp (Widget w, XtPointer client_data, XEvent * event, Boolean * b) 
{
  ((Icon *) client_data)->BtnUp(event);
}
void
Icon::BtnUp ( XEvent * event )
{
  if (event->xbutton.button == Button1 )
    {
      lowerme();
      D->LowerIcons(this);
      if( Draging ) {
          if( 2*(X - (X / D->getsnapX ())* D->getsnapX ()) >  D->getsnapX () )
             X = (X / D->getsnapX ()) * D->getsnapX () + D->getsnapX (); 
             else
             X = (X / D->getsnapX ()) * D->getsnapX ();
          if( 2*(Y - (Y / D->getsnapY ())* D->getsnapY ()) >  D->getsnapY () )
             Y = (Y / D->getsnapY ()) * D->getsnapY () + D->getsnapY (); 
             else
             Y = (Y / D->getsnapY ()) * D->getsnapY ();
          //X = (X / D->getsnapX ()) * D->getsnapX ();
          //Y = (Y / D->getsnapY ()) * D->getsnapY ();
          XtMoveWidget (Win, X, Y);
          XtMoveWidget (Text, X - (TextWidth - WinWidth) / 2, Y + WinHeight + 4);
       Draging = False;
       Save ();
       }
    }
  if (event->xbutton.button == Button3 && P)
    {
      P->Post (event->xbutton.x_root, event->xbutton.y_root);
    }
}
void
Icon::procBtnMotion (Widget w, XtPointer client_data, XEvent * event, Boolean * b)
{
 ((Icon *) client_data)->BtnMotion(event);
}
void
Icon::BtnMotion ( XEvent * event )
{
  //int X, Y, dX, dY;
  if ( Draging )
    {
      X = X + (event->xmotion.x_root - BtnX);
      Y = Y + (event->xmotion.y_root - BtnY);
      BtnX = event->xmotion.x_root;
      BtnY = event->xmotion.y_root;
      if (X < 0)
	X = 0;
      if (Y < 0)
	Y = 0;
      if (X + WinWidth  > WidthOfScreen (D->Scr ()))
	X = WidthOfScreen (D->Scr ()) - WinWidth;
      if (Y + WinHeight > HeightOfScreen (D->Scr ()))
	Y = HeightOfScreen (D->Scr ()) - WinHeight;
      XtMoveWidget (Win, X, Y);
      XtMoveWidget (Text, X - (TextWidth - WinWidth) / 2, Y + WinHeight + 4);
    }
}
void
Icon::Execute (void)
{
  pid_t pid2, pid = fork ();
  switch (pid)
    {
    case -1:
      fprintf (stderr, "Fork in Icon::Execute(X) Failed.\n");
      exit (1);
      break;
    case 0:
      if ((pid2 = fork ()) < 0)
	{
	  fprintf (stderr, "Fork in Icon::Execute(X) Failed.\n");
	  exit (1);
	}
      if (pid2 == 0)
	{
	  // execlp("/bin/sh", "sh", "-c", Command, NULL);
	  // bugfix: the previous line didn't work on my system (Gentoo
	  // 1.4_r
	  // c1/2.4.19-xfs-rc2) -- csm
	  switch (type)
	    {
	    case IconProgram:
	      execlp ("/bin/sh", "/bin/sh", "-c", Command, NULL);
	      fprintf (stderr, "Icon::Execute( \"%s\" ) Failed.\n", Command);
	      exit (1);
	    case IconMount:
	      if (Mounted)
		execlp ("umount", "umount", Caption, NULL);
	      else
		execlp ("mount", "mount", Caption, NULL);
	    default:
	      break;
	    }
	}
      exit (0);
      break;
    }
  XtUnmapWidget (Win);
  XSync (dtDisplay, False);
  waitpid (pid, NULL, 0);
  usleep (200000);
  XtMapWidget (Win);
}

void
Icon::updateMount (Boolean state)
{
  int rc;
  switch(type) {
  case IconMount:
  // printf("Update %s\n", Caption);
  if (state == Mounted)
    return;
  switch (state)
    {
    case True:
      XSetWindowBackgroundPixmap (dtDisplay, XtWindow (WinLabel), pixmap[1]);
      XShapeCombineMask (XtDisplay (Win), XtWindow (Win),
			 ShapeBounding, 0, 0, mask[1], ShapeSet);
      XSync (dtDisplay, False);
      break;
    case False:
      XSetWindowBackgroundPixmap (dtDisplay, XtWindow (WinLabel), pixmap[0]);
      XShapeCombineMask (XtDisplay (Win), XtWindow (Win),
			 ShapeBounding, 0, 0, mask[0], ShapeSet);
      XSync (dtDisplay, False);
      break;
    default:
      break;
    }
  Mounted = state;
  break;
  case IconPlugin:
       rc = (*ptrUpdate)( &PluginState, &Caption);
       if( !rc ) break;
       if( rc & 1 ) {
       CreateCaptionImage();
       XSetWindowBackgroundPixmap (dtDisplay, XtWindow (TextLabel), tpixmap);
       if( !(CaptionBack>0) ) {
       XShapeCombineMask (XtDisplay (Win), XtWindow (Text),
                           ShapeBounding, 0, 0, tmask, ShapeSet);
       XShapeCombineMask (XtDisplay (Win), XtWindow (Text),
                           ShapeBounding, 1, 1, tmask, ShapeUnion);
       }
       XtUnmapWidget(Text);
       XtMapWidget(Text);
       XFlush(XtDisplay (Win));
       XSync(XtDisplay (Win),False);
			   }
       if( rc & 2 ) {
       Pixmap p, m;
       int w,h;
       p = D->getEPixmap();
       m = D->getEMask();
       w = D->getEPixmapWidth();
       h = D->getEPixmapHeight();
       if(PluginState>=0 && PluginState<MaxIconImages && pixmap[PluginState]) {
       p = pixmap[PluginState];
       m = mask[PluginState];
       w = WinWidth;
       h = WinHeight;
       }
       XSetWindowBackgroundPixmap (dtDisplay, XtWindow (WinLabel), 
                           p);
       XShapeCombineMask (XtDisplay (Win), XtWindow (Win),
                           ShapeBounding, 0, 0, m, ShapeSet);
			   }
       XSync (dtDisplay, False);
  break;
  default: ;
  break;
  }
}

void
Icon::Save (void)
{
  Database *IconDb;
  Table *IconTb;
  char Num[10];
  IconDb = new Database (ConfigFile);
  if (!(IconTb = IconDb->Query ("Icon")))
    return;
  sprintf (Num, "%d", X);
  IconTb->Set ("X", Num);
  sprintf (Num, "%d", Y);
  IconTb->Set ("Y", Num);
  IconDb->Write ();
  delete IconDb;
}


void Icon::MakePixmapMap( int pwidth, int pheight, Pixmap pixmap,
unsigned long color, unsigned char *bitmap ) {
XImage *xi = XGetImage (dtDisplay, pixmap, 0, 0, pwidth, pheight,
AllPlanes, ZPixmap);
int i, j, rbytes = (int)pwidth/8 + ( (pwidth%8 > 0)?1:0 );
for (j = 0; j < pheight; j++)
for (i = 0; i < pwidth; i++) {
if (XGetPixel (xi, i, j) != color) {
//printf("i - %d, j - %d\n", i, j);
bitmap[ rbytes*j + i/8 ] |= (unsigned char) 1<<(i%8);
}
}
XDestroyImage(xi); 
}
int Icon::findIconHeight( Table *T, int height ) {
int rc = atoi( (char *) T->Query ("IconHeight").c_str () );
if( rc > 0 ) return rc;
rc = D->getIconHeight();
return ( rc > 0 ) ? rc : height;
}
int Icon::findIconWidth( Table *T, int width ) {
int rc = atoi( (char *) T->Query ("IconWidth").c_str () );
if( rc > 0 ) return rc;
rc = D->getIconWidth();
return ( rc > 0 ) ? rc : width;
}

static char *ExpandHOME( string path ) {
     string home = "$HOME";
     string homePath = getenv("HOME");
     string::size_type pos = path.find(home.c_str(), 0);
     if( pos != string::npos ) {
       path.replace(pos, home.length(), homePath);
     }
     return strdup( path.c_str() );
}

void Icon::CreateImages(Table *T) {
  if (T->Query ("Type") == "Program")
    type = IconProgram;
  else if (T->Query ("Type") == "Mount")
    type = IconMount;
  else if (T->Query ("Type") == "Plugin")
    type = IconPlugin;
  else
    {
      //printf ("Icon type not set in : %s\n", ConfigFile);
      //exit (1);
      snprintf(ErrStr, MaxErrLen, "Icon type not set in : \"%s\"", ConfigFile);
      throw(ErrStr);
    }
  switch (type)
    {
    case IconProgram:
      ImageFile = ExpandHOME(T->Query ("Icon")); //strdup ((char *) T->Query ("Icon").c_str ());
      checkAccess(ImageFile, R_OK);
      Image = Imlib_load_image (dtId, ImageFile);
      if(!Image) { //fprintf(stderr, "Unable to load Icon file \"%s\"",
                   //        ImageFile);
		   //exit(1); 
         snprintf(ErrStr, MaxErrLen, "Unable to load Icon file \"%s\"",
	          ImageFile);
		  throw(ErrStr);
		   }
      WinWidth = findIconWidth(T, Image->rgb_width);
      WinHeight = findIconHeight(T, Image->rgb_height);
      Imlib_render (dtId, Image, WinWidth, WinHeight);
      pixmap[0] = Imlib_move_image (dtId, Image);
      mask[0] = Imlib_move_mask (dtId, Image);
      //for toolbar
      Imlib_destroy_image (dtId, Image);
      break;
    case IconMount:
      ImageFile =  ExpandHOME( T->Query ("IconUmount") ); //strdup ((char *) T->Query ("IconUmount").c_str ());
      checkAccess(ImageFile, R_OK);
      Image = Imlib_load_image (dtId, ImageFile);
      WinWidth = findIconWidth(T, Image->rgb_width);
      WinHeight = findIconHeight(T, Image->rgb_height);
      Imlib_render (dtId, Image, WinWidth, WinHeight);
      pixmap[0] = Imlib_move_image (dtId, Image);
      mask[0] = Imlib_move_mask (dtId, Image);
      ImageFile2 = ExpandHOME( T->Query ("IconMount") ); //((char *) T->Query ("IconMount").c_str ());
      checkAccess(ImageFile2, R_OK);
      Image2 = Imlib_load_image (dtId, ImageFile2);
      Imlib_render (dtId, Image2, WinWidth, WinHeight);
      pixmap[1] = Imlib_move_image (dtId, Image2);
      mask[1] = Imlib_move_mask (dtId, Image2);
      D->setCheckMountProc (this);
      Mounted = False;
      Imlib_destroy_image (dtId, Image);
      Imlib_destroy_image (dtId, Image2);
      break;
    case IconPlugin:
      char tmpbuf[30];
      for(int i=0; i< MaxIconImages; i++) {
         snprintf(tmpbuf, sizeof(tmpbuf)-2, "IconImage%d", i);
         ImageFile = (char *) T->Query (tmpbuf).c_str ();
	 if( !strcmp(ImageFile, "") ) {
#ifdef PRNDEBUG  
	   printf("Empty image[%d]\n", i);
#endif
	   pixmap[i] = mask[i] = 0;
	   continue;
	 }
         checkAccess( (char *) T->Query (tmpbuf).c_str (), R_OK);
	 Image = Imlib_load_image (dtId, (char *) T->Query (tmpbuf).c_str ());
	 if(!Image) {fprintf(stderr, "unable to load image[%d]: \"%s\"\n",
	             i, (char *) T->Query (tmpbuf).c_str () );
		     exit(1);
		     }
	 if( (WinWidth == 0) || (WinHeight == 0) ) {
	    WinHeight = findIconHeight(T, Image->rgb_height);
	    WinWidth = findIconWidth(T, Image->rgb_width);
	   }
	   Imlib_render (dtId, Image, WinWidth, WinHeight);
	   pixmap[i] = Imlib_move_image (dtId, Image);
	   mask[i] = Imlib_move_mask (dtId, Image);
	   Imlib_destroy_image (dtId, Image);
#ifdef PRNDEBUG  
	   printf("image[%d] \"%s\" %dx%d\n", i, ImageFile,WinWidth,WinHeight);
#endif
      }
      if( (WinWidth == 0) || (WinHeight == 0) ) {
        for(int i=0; i<MaxIconImages; i++) {
          pixmap[i] = D->getEPixmap();
	  mask[i]   = D->getEMask();
	}
      WinWidth  = D->getEPixmapWidth();
      WinHeight = D->getEPixmapHeight();
      }
      char *error;
      if(!dlopen (NULL, RTLD_LAZY|RTLD_GLOBAL)) {
      //fprintf (stderr, "dlopen NULL (2) %s\n", dlerror());
      //exit(1);
      snprintf(ErrStr, MaxErrLen, "dlopen NULL (2) %s",
              dlerror());
      throw(ErrStr);
						   
      }

      dlptr = dlopen ( (char *) T->Query ("Library").c_str (), RTLD_LAZY );
      if (!dlptr) {//fprintf (stderr, "Dlerror %s\n", dlerror());
                   // exit(1); 
	snprintf(ErrStr, MaxErrLen, "Dlerror %s", dlerror());
	throw(ErrStr);
      }
      ptrInit = (int (*)(Table*))dlsym(dlptr, "Init");
      if ((error = (char*)dlerror()) != NULL)  {
	 snprintf(ErrStr, MaxErrLen, "dlsym init : %s", error);
	 throw(ErrStr);
	 }
      ptrUpdate = (int (*)(int *, char **))dlsym(dlptr, "Update");
      if ((error = (char *)dlerror()) != NULL)  {
	 snprintf(ErrStr, MaxErrLen, "dlsym Update : %s", error);
	 throw(ErrStr);
	 }
      (*ptrInit)(T);
      D->setCheckMountProc (this);
#ifdef PRNDEBUG  
       printf("Plugin init complete, caption:%s\n", Caption);
#endif
      break;
    default:
      snprintf(ErrStr, MaxErrLen, "Type not specified for %s", Caption);
      throw(ErrStr);
    }
 }


 
void Icon::CreateIconWindow(void) {
  Win =
    XtVaCreateWidget ("iconImg", topLevelShellWidgetClass, D->Wget (),
		      "x", X, "y", Y, NULL);
  WinLabel = XtVaCreateManagedWidget ("label", labelWidgetClass,
				      Win,
				      "label", "",
				      "cursorName", "hand2", NULL);
  if(type==IconMount || type==IconProgram) {			      
  XtRealizeWidget (Win);
  XSetWindowBackgroundPixmap (dtDisplay, XtWindow(WinLabel), pixmap[0]);
  XtConfigureWidget (Win, X, Y, WinWidth, WinHeight, 0);
  if (mask[0])
    XShapeCombineMask (XtDisplay (Win), XtWindow (Win),
		       ShapeBounding, 0, 0, mask[0], ShapeSet);
  if (type == IconProgram)
    Imlib_free_pixmap (dtId, pixmap[0]);
    return;
    }
    // for IconPlugin only
  int rc = (*ptrUpdate)( &PluginState, &Caption);
  if( rc & 3 != 3) {
  snprintf(ErrStr, MaxErrLen, "First call to plugin does not return full info");
  throw(ErrStr);
  }
  if(PluginState<0 || PluginState>=MaxIconImages) {
  snprintf(ErrStr, MaxErrLen, "First call to plugin returned wrong state: %d", PluginState); 
  throw(ErrStr);
  }
  if(!pixmap[PluginState]) {
  snprintf(ErrStr, MaxErrLen, "First call to plugin return wrong pixmap - %d", PluginState);
  throw(ErrStr);
    }
  XtRealizeWidget (Win);
  XSetWindowBackgroundPixmap (dtDisplay, XtWindow(WinLabel), pixmap[PluginState]);
  if(mask[PluginState])
  XShapeCombineMask (XtDisplay (Win), XtWindow (Win),
                     ShapeBounding, 0, 0, mask[PluginState], ShapeSet);
  XtConfigureWidget (Win, X, Y, WinWidth, WinHeight, 0);
  }



void Icon::CreateMenu(Table *T) {
  char menuCmd[25] = "MenuCommand1";
  int i;
  for (i = 0; i < MaxMenuCommands; i++)
    {
      snprintf(menuCmd, sizeof(menuCmd)-2, "MenuCommand%d", i);
      if (strlen ((char *) T->Query (menuCmd).c_str ()))
	{
	  MenuCommand[i] = strdup ((char *) T->Query (menuCmd).c_str ());
	  if (!P)
	    P = new PopupMenu (Win, Caption);
	  P->AddCommand (menuCmd, MenuCommand[i]);
	}
      else
	MenuCommand[i] = NULL;
      //++menuCmd[11];
    }
    if (!P) P = new PopupMenu (Win, Caption);
       else { 
       snprintf(menuCmd, sizeof(menuCmd)-2, "MenuCommand%d", i++);
       P->AddCommand (menuCmd, "Separator");
       }
       snprintf(menuCmd, sizeof(menuCmd)-2, "MenuCommand%d", i++);
       P->AddProps ("propsMenuCmd", this); 
}


void Icon::SetEventHandlers(void) {
  if(WinLabel) {
  XtAddEventHandler (WinLabel, ButtonPressMask, False, procBtnDown,
		     (XtPointer) this);
  XtAddEventHandler (WinLabel, ButtonReleaseMask, False, procBtnUp,
		     (XtPointer) this);
  XtAddEventHandler (WinLabel, Button1MotionMask, False, procBtnMotion,
		     (XtPointer) this);
  }
  if(TextLabel) {
  XtAddEventHandler (TextLabel, ButtonPressMask, False, procBtnDown,
		     (XtPointer) this);
  XtAddEventHandler (TextLabel, ButtonReleaseMask, False, procBtnUp,
		     (XtPointer) this);
  XtAddEventHandler (TextLabel, Button1MotionMask, False, procBtnMotion,
		     (XtPointer) this);
  }
  }


void Icon::CreateCaptionImage(void) {
  int direction, ascent, descent, numext=0, curext=0;
  int c_margin = (CaptionBack>0) ? 2 : 0;
  int  curh=(CaptionBack>0) ? c_margin : 0;
  int space = 0;
  XRectangle r1, r2;
  XCharStruct overall;
  GC black_gc, white_gc;
  XGCValues values;
  char *p, *q;
  if(tpixmap) XFreePixmap(dtDisplay, tpixmap);
  if(tmask)    XFreePixmap(dtDisplay, tmask); 
  //delete leading \n and double \n
  while((p=strstr(Caption, "\\n\\n")) != NULL)
     strcpy(p, p+4);
  if(!strcmp(Caption, "\\n"))
     strcpy(Caption, Caption+2);
  if(!strlen(Caption)) {
    tpixmap = D->getEPixmap();
    tmask = D->getEMask();
    TextWidth = D->getEPixmapWidth();
    TextHeight = D->getEPixmapHeight();
    return;
  }
  //separate rows in caption
  p = Caption;
  TextWidth = TextHeight = 0;
  while(1) {
    if( (q=strstr(p, "\\n")) != NULL ) {
      *q++ = 0; *q++ = 0;
      }
  XmbTextExtents(D->fontset, p, strlen(p), NULL, &r2 );
  TextHeight = TextHeight + r2.height + ((numext)?(space):(0));
  TextWidth = (TextWidth> (r2.width + 4))?(TextWidth):(r2.width + 4);
  //printf("%s: width %d, height %d  TextWidth %d\n", p, r2.width, r2.height, TextWidth);
  ++numext;
  if(!q) break;
  if(!*q) break;
  p = q;
  } 
  TextHeight += 2*c_margin;
  TextWidth += 2*c_margin;
  //printf("width %d, height %d extents %d\n", TextWidth, TextHeight, numext);
  tpixmap = XCreatePixmap (dtDisplay,
			       dtRoot,
			       TextWidth, 
                               TextHeight,  
			       DefaultDepthOfScreen(dtScreen));
  values.foreground = D->fntBack ();
  white_gc = XCreateGC (dtDisplay, tpixmap, GCForeground, &values);
  XFillRectangle (dtDisplay, tpixmap, white_gc, 0, 0, TextWidth, TextHeight);
  XFreeGC (dtDisplay, white_gc);
  values.foreground = D->fntFore ();
  values.background = D->fntBack ();
  black_gc =
    XCreateGC (dtDisplay, tpixmap, GCForeground | GCBackground, &values);
  if( CaptionBorder )
      XDrawRectangle (dtDisplay, tpixmap, black_gc, 0, 0, TextWidth - 1, TextHeight - 1);
  p = Caption;
  while(curext < numext) {
    if(!strlen(p)) {
    //should never happen
    break; 
    }
  XmbTextExtents(D->fontset, p, strlen(p), NULL, &r2 );
  XmbDrawImageString(dtDisplay, tpixmap, D->fontset, black_gc,
                      (CaptionAlign=='c') ? (TextWidth-r2.width)/2 : (2+c_margin),
                      curh -r2.y, p, strlen(p));
  curh +=space;
  curh += r2.height;
  p = p + strlen(p);
  ++p; ++p;
  ++curext;
  }
  XFreeGC (dtDisplay, black_gc);
  unsigned char *bitmap = (unsigned char*) calloc(
                      TextHeight*(TextWidth/8 + ((TextWidth%8 > 0)?1:0) ), 
		      sizeof(unsigned char) );
  if(!bitmap) { //printf( "calloc failed\n"); exit(1); 
  snprintf(ErrStr, MaxErrLen, "Calloc failed in CreateCaptionImage");
  throw(ErrStr);
  }
  XImage *xi = XGetImage (dtDisplay, tpixmap, 0, 0, TextWidth, TextHeight,
		  AllPlanes, ZPixmap);
  MakePixmapMap(TextWidth, TextHeight, tpixmap, values.background, bitmap);
  tmask = XCreatePixmapFromBitmapData(dtDisplay, dtRoot, 
                (char*)bitmap, TextWidth, TextHeight, 
		WhitePixel (dtDisplay, DefaultScreen(dtDisplay)),
		BlackPixel (dtDisplay, DefaultScreen(dtDisplay)),
		1);
  XDestroyImage (xi);
  free (bitmap);
}

void Icon::CreateCaptionWindow(void) {
  if( tpixmap) {
    Text = XtVaCreateWidget ("iconTxt", topLevelShellWidgetClass,
			   D->Wget (),
			   "x", X - (TextWidth - WinWidth) / 2,
			   "y", Y + WinHeight + 4, NULL);
    TextLabel = XtVaCreateManagedWidget ("label", labelWidgetClass,
				       Text,
				       "borderWidth", 0,
				       "label", "",
				       "backgroundPixmap", tpixmap, NULL);
    XtConfigureWidget (Text, X - (TextWidth - WinWidth) / 2,
		     Y + WinHeight + 4, TextWidth, TextHeight, 0);
    XtRealizeWidget (Text);
  }
  if(tmask && !(CaptionBack>0)) {
    XShapeCombineMask (XtDisplay (Text), XtWindow (Text),
                            ShapeBounding, 0, 0, tmask, ShapeSet);
    XShapeCombineMask (XtDisplay (Text), XtWindow (Text),
                            ShapeBounding, 1, 1, tmask, ShapeUnion);
  }
 }

void Icon::OverrideRedirect(void) { 
  XSetWindowAttributes Attr;
  Attr.override_redirect = True;
  Attr.event_mask = SubstructureRedirectMask | SubstructureNotifyMask | ButtonPressMask | ButtonReleaseMask | PointerMotionMask;	// |EnterWindowMask|LeaveWindowMask;
  if(Win)
  XChangeWindowAttributes (dtDisplay, XtWindow (Win),
			   CWOverrideRedirect | CWEventMask, &Attr);
//  XChangeWindowAttributes (dtDisplay, XtWindow (WinLabel),
//			   CWEventMask, &Attr);
//  printf("===>\n");
  Attr.override_redirect = True;
  if(Text)
  XChangeWindowAttributes (dtDisplay, XtWindow (Text),
			   CWOverrideRedirect, &Attr);
 }
void Icon::checkAccess( char *path, int mode ) {
      if( access(path, mode) ) {
        snprintf(ErrStr, MaxErrLen, "Can't access file \"%s\"\n",
                 ImageFile);
                 throw(ErrStr);
      }
}
