#ifndef __icon_h__
#define __icon_h__

#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <dlfcn.h>
#ifdef LINUX
#include <bits/dlfcn.h>
#endif
#include <Imlib.h>
#include "desk.h"
#include "menu.h"
#include "Database.h"

#define IconProgram 0
#define IconMount   1
#define IconPlugin  2
class Icon
{
private:
  Desk * D;
  PopupMenu *P;
#define MaxMenuCommands 32
  char *MenuCommand[MaxMenuCommands+2];
#define MaxErrLen 80
  char ErrStr[MaxErrLen+1];
#define MaxIconImages 20
  Pixmap pixmap[MaxIconImages]; 
  Pixmap mask[MaxIconImages];
  Pixmap tpixmap, tmask;
  Pixmap tbpixmap[MaxIconImages];
  Pixmap tbmask[MaxIconImages];
  int PluginState;
#define dtId D->Im()
#define dtDisplay  D->Disp()
#define dtScreen  D->Scr()
#define dtRoot    D->Root()
#define dClick D->getClickInterval()
  Widget Win, Text, WinLabel, TextLabel;
  ImlibImage *Image, *Image2;
  //Pixmap pixmap, mask, pixmap2, mask2, pixmap3, mask3;
  int type;
  char *Fixed, *Command, *Caption, *ConfigFile, *ImageFile, *ImageFile2,
       CaptionAlign;
  int X, Y, WinWidth, WinHeight, TextWidth, TextHeight, iFixed,
      CaptionBack, CaptionBorder;
  int BtnTime, BtnX, BtnY;
  Boolean Mounted;
  void Save (void);
  void  *dlptr;
  int   (*ptrInit)(Table *);
  int   (*ptrUpdate)(int *, char **);
  static void procBtnDown (Widget w, XtPointer client_data,
			   XEvent * event, Boolean * b);
	 void BtnDown ( XEvent * event );
  static void procBtnUp (Widget w, XtPointer client_data,
			 XEvent * event, Boolean * b);
	 void BtnUp (XEvent * event);
  static void procBtnMotion (Widget w, XtPointer client_data,
			     XEvent * event, Boolean * b);
	 void BtnMotion ( XEvent * event);
  void MakePixmapMap( int pwidth, int pheight, Pixmap pixmap,
                   unsigned long color, unsigned char *bitmap );
  void CreateImages(Table *T);
  void CreateIconWindow(void);
  void CreateCaptionWindow(void);
  void CreateCaptionImage(void);
  void CreateMenu(Table *T);
  void SetEventHandlers(void);
  void OverrideRedirect(void);
  int findIconHeight( Table *T, int height );
  int findIconWidth( Table *T, int width );
public:
  int Draging; 
    Icon (Desk * Dsk, char *File, Table * T);
  //char *Cap, char *Com, int X, int Y);
   ~Icon (void)
  {
  delete P;
  XtDestroyWidget(Win);
  XtDestroyWidget(Text);
  };
  char *getCaption (void)
  {
    return Caption;
  };
  void Execute (void);
  inline Desk *getDesk (void)
  {
    return D;
  };
  /*
  inline int getWinWidth (void)
  {
    return WinWidth;
  };
  inline int getWinHeight (void)
  {
    return WinHeight;
  };
  */
  void updateMount (Boolean state);
  inline char* getConfigFile(void) { return ConfigFile; };
  void checkAccess( char *path, int mode ); 
  void Icon::raiseme (void);
  void Icon::lowerme (void);
};

#endif
