#include <unistd.h>
#include "desk.h"
#include "icon.h"
#include <dlfcn.h>
#ifdef LINUX
#include <bits/dlfcn.h>
#endif

#ifdef NO_MEMORY
ImlibImage* (*ptrImlib_load_image)(ImlibData *id, char *file);
int (*ptrImlib_render)(ImlibData *id, ImlibImage *image, int width, int height);
Pixmap (*ptrImlib_move_image)(ImlibData *id, ImlibImage *image);
Pixmap (*ptrImlib_move_mask)(ImlibData *id, ImlibImage *image);
void (*ptrImlib_destroy_image)(ImlibData *id, ImlibImage *image);
void (*ptrImlib_free_pixmap)(ImlibData *id, Pixmap pixmap);
ImlibData *(*ptrImlib_init_with_params)(Display *disp, ImlibInitParams *p);

ImlibImage* Imlib_load_image(ImlibData *id, char *file) {
return (*ptrImlib_load_image)( id, file);
}
int Imlib_render(ImlibData *id, ImlibImage *image, int width, int height) {
return (*ptrImlib_render)( id, image, width, height);
}
Pixmap Imlib_move_image(ImlibData *id, ImlibImage *image) {
return (*ptrImlib_move_image)( id, image);
}
Pixmap Imlib_move_mask(ImlibData *id, ImlibImage *image) {
return (*ptrImlib_move_mask)( id, image);
}
void Imlib_destroy_image(ImlibData *id, ImlibImage *image) {
return (*ptrImlib_destroy_image)( id, image);
}
void Imlib_free_pixmap(ImlibData *id, Pixmap pixmap) {
return (*ptrImlib_free_pixmap)( id, pixmap);
}
ImlibData *Imlib_init_with_params(Display *disp, ImlibInitParams *p) {
return (*ptrImlib_init_with_params)( disp, p);
}

void *handle;
void dlcheckerror(char *sym) {
     char *error;
     if ((error = dlerror()) == NULL)  return;
     fprintf (stderr, "Error loading %s : %s\n", sym, error);
}
void InitImgLib(void) {
     handle = dlopen ("libImlib.so.1", RTLD_LAZY);
     ptrImlib_load_image = (ImlibImage *(*)(ImlibData*, char*))dlsym(handle, "Imlib_load_image"); 
     dlcheckerror("Imlib_load_image");
     ptrImlib_render = (int (*)(ImlibData*, ImlibImage*, int, int))dlsym(handle, "Imlib_render"); 
     dlcheckerror("Imlib_render");
     ptrImlib_move_image = (Pixmap (*)(ImlibData*, ImlibImage*))dlsym(handle, "Imlib_move_image"); 
     dlcheckerror("Imlib_move_image");
     ptrImlib_move_mask = (Pixmap (*)(ImlibData*, ImlibImage*))dlsym(handle, "Imlib_move_mask"); 
     dlcheckerror("Imlib_move_mask");
     ptrImlib_destroy_image = (void (*)(ImlibData*, ImlibImage*))dlsym(handle, "Imlib_destroy_image"); 
     dlcheckerror("Imlib_destroy_image");
     ptrImlib_free_pixmap = (void (*)(ImlibData*, long unsigned int))dlsym(handle, "Imlib_free_pixmap"); 
     dlcheckerror("Imlib_free_pixmap");
     ptrImlib_init_with_params = (ImlibData*(*)(Display*, ImlibInitParams*))dlsym(handle, "Imlib_init_with_params"); 
     dlcheckerror("Imlib_init_with_params");
}
void CloseImgLib(void) {
     dlclose(handle);
}
#endif


Desk *D;
Desk *getDesktop(void) { return D; }
void procSigAlrm (XtPointer client_data, XtIntervalId* id) {
  D->ExecJobs ();
  XtAppAddTimeOut((XtAppContext)client_data, 1000, 
                   procSigAlrm, (XtPointer)client_data);
}
int makeBooleanFromStr(char *str, int dflt) {
int rc;
if( !str || !strlen( str ) ) rc = -1;
  else 
  if( !strcmp( str, "1") || !strcasecmp(str, "y") ||
    !strcasecmp(str, "yes") || !strcasecmp(str, "true") )
    rc =  1;
    else 
    rc = 0;
if( dflt >= 0 )
   return (rc>0 || (rc<0 && dflt>0 ) ) ? 1 : 0;
   else
   return rc;
}
int
main (int argc, char **argv)
{
XtSetLanguageProc (NULL, NULL, NULL);
#ifdef NO_MEMORY
  InitImgLib();
#endif  
  D = new Desk (&argc, argv);
#ifdef NO_MEMORY
  CloseImgLib();
#endif  
#ifdef PRNDEBUG
  printf ("Desktop created\n");
#endif
  XtAppAddTimeOut( D->GetAppContext(), 1000, procSigAlrm, D->GetAppContext());
  D->MainLoop ();
}
