#include "menu.h"
#include "minimize.xbm"
#include "textfile.xbm"
#include <X11/cursorfont.h>
#include "desk.h"
static int bflag = 0;
Pixmap p1 = 0, p2 = 0;
void procProperties(Widget w, XtPointer client_data, XtPointer call_data);
PopupMenu::PopupMenu (Widget w, String title)
{
 int titleok = 0; char *p;
  p = title;
  menu = XtVaCreatePopupShell ("popup_menu", simpleMenuWidgetClass, w, 
			       XtNlabel, title,
                               NULL);
  
  lastEntry = 0;
  if (!bflag)
    {
      p1 = XCreateBitmapFromData (XtDisplay (w), XtWindow (w),
				  (char *) textfile_bits, textfile_width,
				  textfile_height);
      p2 =
	XCreateBitmapFromData (XtDisplay (w), XtWindow (w),
			       (char *) minimize_bits, minimize_width,
			       minimize_height);
      if (!p1 || !p2)
	{
	  fprintf (stderr, "Menu Bitmaps creation failed\n");
	  _exit (1);
	}
      bflag = 1;
    }
  //lastEntry = XtVaCreateManagedWidget("mm_title", smeBSBObjectClass, menu,
  //              "label", title, "leftBitmap", p1, 
  //            "leftMargin", tick_width+4, 
  //            NULL );
  lastEntry = XtVaCreateManagedWidget ("mm_line", smeLineObjectClass, menu,
                                        NULL);
//  				       XtNfromVert, lastEntry, NULL);
  XtAddEventHandler (menu, LeaveWindowMask, False, procUnpost,
		     (XtPointer) this);
}

void XawPositionSimpleMenu (Widget w);
void
PopupMenu::Post (int x, int y)
{
  XtWidgetGeometry g;
  XtPopup (menu, XtGrabNone);
  x -= 2;
  y -= 2;
  //XtMoveWidget(menu, x, y); 
  XtQueryGeometry (menu, NULL, &g);
  //printf ("Geometry: %d %d, %dx%d\n", g.x, g.y, g.width, g.height);
  if (x + g.width > WidthOfScreen (XtScreen (menu)))
    x = WidthOfScreen (XtScreen (menu)) - g.width;
  if (y + g.height > HeightOfScreen (XtScreen (menu)))
    y = HeightOfScreen (XtScreen (menu)) - g.height;
  if (x < 0)
    x = 0;
  if (y < 0)
    y = 0;
  XtMoveWidget (menu, x, y);
  //XawPositionSimpleMenu(menu);
}

void
PopupMenu::procUnpost (Widget w, XtPointer client_data,
		       XEvent * event, Boolean * b)
{
  PopupMenu *P = (PopupMenu *) client_data;
  P->Unpost ();
}
extern Desk *D;
void
PopupMenu::AddCommand (char *item, char *command)
{
//   static char *trans = "<EnterWindow>:Highlight( )\n<LeaveWindow>:Unhighlight( )";
//   static XtTranslations ptrans; 
  char *c, *l = strdup (command);
  c = strchr (l, ':');
  if (c)
    {
      *c = 0;
      ++c;
    }
  if( !strcmp(l, "Separator") ) {
    lastEntry = XtVaCreateManagedWidget (item, smeLineObjectClass, menu,
                                         XtNfromVert, lastEntry, NULL);
    return;
  }
  lastEntry = XtVaCreateManagedWidget (item, smeBSBObjectClass, menu,
				       "label", l, "leftBitmap", p2,
				       "leftMargin", minimize_width + 4,
                                       "fontSet", XtDefaultFontSet,
				       NULL);
//   printf("starting translation\n");
//   ptrans = XtParseTranslationTable(trans); 
//   if(!ptrans) printf("translation failed\n");
//                printf("translation Ok\n");
//   XtOverrideTranslations(lastEntry, ptrans);
//   printf("translation added\n");
  if (c)
    {
      //printf ("Add callback for: %s\n", c);
      XtAddCallback (lastEntry, XtNcallback, (XtCallbackProc) procExec,
		     (XtPointer) c);
    }
  //free(l);
}
void
PopupMenu::AddProps(char *item, Icon *I) {
 lastEntry = XtVaCreateManagedWidget (item, smeBSBObjectClass, menu,
                                      "label", "Properties", "leftBitmap", p1,
				      "leftMargin", textfile_width + 4,
				      NULL);
 XtAddCallback (lastEntry, XtNcallback, (XtCallbackProc) procProperties,
                (XtPointer) I );
}
void
PopupMenu::procExec (Widget w, XtPointer client_data, XtPointer call_data)
{
  pid_t pid2, pid = fork ();
  printf ("exec for %s\n", client_data);
  switch (pid)
    {
    case -1:
      fprintf (stderr, "Fork1 in PopupMenu::Execute(%s) Failed.\n",
	       client_data);
      _exit (1);
      break;
    case 0:
      if ((pid2 = fork ()) < 0)
	{
	  fprintf (stderr, "Fork2 in PopupMenu::Execute(%s) Failed.\n",
		   client_data);
	  _exit (1);
	}
      if (pid2 == 0)
	{
	  execlp ("/bin/sh", "/bin/sh", "-c", (char *) client_data, NULL);
	  fprintf (stderr, "Exec in PopupMenu::Execute(%s) Failed.\n",
		   client_data);
	  _exit (1);
	}
      _exit (0);
      break;
    }
  waitpid (pid, NULL, 0);
}
