#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <dlfcn.h>
#include <bits/dlfcn.h>
#include <time.h>
#define MAXCPU 4
static char tbuf[350];
struct CPU_stat_struct {
int active;
long long cusrcpu, csyscpu, ctotalcpu;
long long  usrcpu,  syscpu,  totalcpu;
float usr, sys;
char info[100];
} cpu_stat[MAXCPU];
int cpunum = 0;
int cpucount(void) {
 FILE *f = fopen("/proc/cpuinfo", "r");
 while(fgets(tbuf, sizeof(tbuf)-1, f)) {
   if( !memcmp(tbuf, "processor", 9) ) {
      memset(&cpu_stat[cpunum], 0, sizeof(CPU_stat_struct) );
      cpu_stat[cpunum].usr = 0; cpu_stat[cpunum].sys = 0;
      ++cpunum;
    }
 }
 fclose(f);
}
#define MAXETH 10
struct eth_stat_struct {
 int active;
 unsigned long long  crx, ctx, rx, tx;
 float rin, rout;
 char info[100];
} eth_stat[MAXETH];
int ethnum = 0;
int ethcount(void) {
 FILE *f = fopen("/proc/net/dev", "r");
 while(fgets(tbuf, sizeof(tbuf)-1, f)) {
   if( !memcmp(tbuf, "  eth", 5) ) {
      memset(&eth_stat[ethnum], 0, sizeof(eth_stat_struct) );
      eth_stat[ethnum].rin = 0; eth_stat[ethnum].rout = 0;
      ++ethnum;
    }
 }
 fclose(f);
}
int updateeth(void) {
int i, lasti=0;
char ethid[20], *p;
FILE *f = fopen("/proc/net/dev", "r");
lasti = 0;
while(fgets(tbuf, sizeof(tbuf)-1, f)) {
  for(i=lasti; i<ethnum; i++) {
    snprintf(ethid, sizeof(ethid), "eth%d", i);
    p = strstr(tbuf, ethid);
    if(p) {
      p+=5;
      eth_stat[i].crx = strtoll(p, &p, 10);
      eth_stat[i].ctx = strtoll(p, &p, 10);
      eth_stat[i].ctx = strtoll(p, &p, 10);
      eth_stat[i].ctx = strtoll(p, &p, 10);
      eth_stat[i].ctx = strtoll(p, &p, 10);
      eth_stat[i].ctx = strtoll(p, &p, 10);
      eth_stat[i].ctx = strtoll(p, &p, 10);
      eth_stat[i].ctx = strtoll(p, &p, 10);
      eth_stat[i].ctx = strtoll(p, &p, 10);
      //
      if( eth_stat[i].crx <= 0 || eth_stat[i].ctx <= 0 ) 
        snprintf(eth_stat[i].info, sizeof(eth_stat[i].info), "eth%d : down", i);
      else {
        eth_stat[i].rout = 
           (eth_stat[i].tx) ? (eth_stat[i].ctx - eth_stat[i].tx) : 0;
        eth_stat[i].rin = 
           (eth_stat[i].rx)  ? (eth_stat[i].crx - eth_stat[i].rx) : 0;
        snprintf(eth_stat[i].info, sizeof(eth_stat[i].info), 
         "eth%d   rx/tx:%6.1f%s%6.1f%s\\n", i, 
         (eth_stat[i].rin<1048576) ? 
         (float)(eth_stat[i].rin/1024) : (float)(eth_stat[i].rin/1048576),
         (eth_stat[i].rin<1048576) ? "K" : "M",
         (float) (eth_stat[i].rout<1048576) ? 
         (float)(eth_stat[i].rout/1024) : (float)(eth_stat[i].rout/1048576),
         (eth_stat[i].rout<1048576) ? "K" : "M" );
         eth_stat[i].tx = eth_stat[i].ctx;
         eth_stat[i].rx = eth_stat[i].crx;

        }
      //
      lasti = i;
      break;
    }
  } // for
  if( lasti >= ethnum ) break;
} // while
fclose(f);
}
int updateCPU (void) {
 int i, lasti;
 static char cpuid[10];
 char *p;
 FILE *f = fopen("/proc/stat", "r");
 lasti = 0;
 while(fgets(tbuf, sizeof(tbuf)-1, f)) {
   for(i=lasti; i<MAXCPU; i++) {
     snprintf(cpuid, sizeof(cpuid), "cpu%d ", i);
     p = strstr(tbuf, cpuid);
     if(p) {
       p+=4;
       cpu_stat[i].cusrcpu = strtoll(p, &p, 10);
       cpu_stat[i].cusrcpu += strtoll(p, &p, 10);
       cpu_stat[i].csyscpu = strtoll(p, &p, 10);
       cpu_stat[i].ctotalcpu = strtoll(p, &p, 10) + 
                   cpu_stat[i].cusrcpu + cpu_stat[i].csyscpu;
       //
cpu_stat[i].sys = cpu_stat[i].csyscpu - cpu_stat[i].syscpu; 
cpu_stat[i].sys = (cpu_stat[i].syscpu) ? cpu_stat[i].sys : 0;
cpu_stat[i].sys = 100 * cpu_stat[i].sys / (cpu_stat[i].ctotalcpu - cpu_stat[i].totalcpu);
cpu_stat[i].usr = cpu_stat[i].cusrcpu - cpu_stat[i].usrcpu; 
cpu_stat[i].usr = (cpu_stat[i].usrcpu) ? cpu_stat[i].usr : 0;
cpu_stat[i].usr = 100 * cpu_stat[i].usr / (cpu_stat[i].ctotalcpu - cpu_stat[i].totalcpu);
cpu_stat[i].totalcpu = cpu_stat[i].ctotalcpu;
cpu_stat[i].usrcpu = cpu_stat[i].cusrcpu;
cpu_stat[i].syscpu = cpu_stat[i].csyscpu;
       //
       snprintf( cpu_stat[i].info, sizeof(cpu_stat[i].info), 
                 "%susr/sys: %5.1f%% %5.1f%%\\n",
                 cpuid, cpu_stat[i].usr, cpu_stat[i].sys );
       lasti = i;
       break;
     }
   } // end for
 if( lasti >= cpunum ) break;
 } // end while
fclose(f);
}
///////////////////////////////////////////////////////////////////////////
//

struct thermal_stat_struct {
 char info[50];
} thermal_stat;
void updateT (void) {
 char *p;
 FILE *f = fopen("/proc/acpi/thermal_zone/THRM/temperature", "r");
 if(f) {
 fgets(tbuf, sizeof(tbuf)-1, f);
// printf("%s\n", tbuf);
 p = strchr(tbuf, '\n');
 if(p) *p=0;
 p = strchr(tbuf, ':');
 memcpy(tbuf, p+1, strlen(p));
 while(*tbuf == ' ')
   memmove(tbuf, tbuf+1, strlen(tbuf) );
 snprintf(thermal_stat.info, sizeof(thermal_stat.info), "CPU temp    :   %s\\n", tbuf );
 fclose(f);
 } else thermal_stat.info[0]=0;
}

extern "C" void Init(char *ptr) {
     //printf("In plugin init : %s\n", (char *) T->Query ("Library").c_str ());
     cpucount();
     ethcount();
     }
//int main(int argv, char ** argc ) {
extern "C" int Update( int *icon, char **text) {
    int i;
//    Init(NULL);
//    printf("Cpu count: %d\neth count %d\n", cpunum, ethnum);
//while(1) {
   updateCPU();
   updateeth();
   updateT ();
   *tbuf = 0;  
   for( i=0; i<cpunum; i++) {
   strcat(tbuf, cpu_stat[i].info);
//   strcat(tbuf, "\n");
   }
   for( i=0; i<ethnum; i++) {
   strcat(tbuf, eth_stat[i].info);
//   strcat(tbuf, "\n");
   }
   strcat(tbuf, thermal_stat.info);
//   printf("%s\n", tbuf);
//   strcat(tbuf, "\n");
//    sleep(1);
//   }
*icon = 0;
*text = tbuf;
return 1;
}
