#include "icon.h"
#include <X11/Xaw/Form.h>
#include <X11/Xaw/FormP.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/LabelP.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/AsciiTextP.h>

static Widget propsWin = 0, textSrc, s;
extern Desk *D;
static void procCancel(Widget w, XtPointer client_data, XtPointer call_data) {
       XtDestroyWidget(propsWin);
       propsWin = 0;
}
static Atom wm_delete_window = (Atom)0;
///////////////////////////////////////////////////////////////////////////
static void closePropsWin (Widget w, _XEvent *event, String *params, Cardinal *num_params)
{
    if (event->type == ClientMessage &&
        event->xclient.data.l[0] != wm_delete_window) {
        return;
    }
    procCancel(NULL, NULL, NULL);
}
                                                                                
static XtActionsRec propsWin_actions[] = {
    { "quit", closePropsWin },
    NULL
};
///////////////////////////////////////////////////////////////////////////
static void procSave(Widget w, XtPointer client_data, XtPointer call_data) {
       char *f;
       char *ConfigFile = ((Icon*)client_data)->getConfigFile();
       //if( !XtIsWidget(textSrc) ) return;
       if(XawAsciiSourceChanged(textSrc)) {
       f = (char*)malloc( strlen(ConfigFile)+5 );
       strcpy(f, ConfigFile);
       strcat(f, ".bak");
       rename(ConfigFile, f);
       if(XawAsciiSave(textSrc)) {
       try {
          D->CreateIcon( ConfigFile );
	  D->DeleteIcon((Icon*)client_data);
          unlink(f);
	  XtDestroyWidget(propsWin);
	  propsWin = 0;
	  }
	  catch ( char *eStr ) {
	     XtVaSetValues(s, XtNlabel, eStr, NULL);
	     fprintf(stderr,"%s\n",  eStr);
	     rename(f, ConfigFile);
	  }
	 //if ( D->CreateIcon( ConfigFile ) )
	 //   D->DeleteIcon((Icon*)client_data);
	 }
       free(f);
       } else {
       fprintf(stderr, "Config %s not changed.\n", ConfigFile);
       XtVaSetValues(s, XtNlabel, "Save : no changes made.", NULL);
       }
}
void procProperties(Widget w, XtPointer client_data, XtPointer call_data) {
    Widget f0, f1, l1, l2, f2, e1, f3, b1, b2;
    char *ConfigFile = ((Icon*)client_data)->getConfigFile();
#ifdef PRNDEBUG
    printf("Props for %s\n", ConfigFile);
#endif
    if(propsWin) XtDestroyWidget(propsWin);
    propsWin = XtVaCreateWidget ("propsWindow", topLevelShellWidgetClass, 
               D->Wget (), XtNtitle, ConfigFile, NULL);
/////////////////////////////////////////
    XtAppAddActions ( D->GetAppContext(), propsWin_actions, XtNumber(propsWin_actions));
    XtOverrideTranslations(propsWin,
              XtParseTranslationTable ("<Message>WM_PROTOCOLS: quit()"));
////////////////////////////////////////
    f0 = XtVaCreateManagedWidget("form0", formWidgetClass, propsWin,
         "x", 0, "y", 0,  NULL);
    f1 = XtVaCreateManagedWidget("form1", formWidgetClass, f0, 
         "borderWidth", 0, "defaultDistance", 0,
         "fromVert", NULL, 
	 "top", XawChainTop,
	 "bottom", XawChainTop,
	 "left", XawChainLeft,
	 NULL);
    l1 = XtVaCreateManagedWidget("label1", labelWidgetClass, f1, 
         "borderWidth", 0,
         "label", "Config :", "fromVert", NULL, 
	 "top", XawChainTop,
	 "bottom", XawChainTop,
	 "left", XawChainLeft,
	 NULL);
    l2 = XtVaCreateManagedWidget("label2", labelWidgetClass, f1,
         "borderWidth", 0,
         "label", ConfigFile, "fromHoriz", l1, 
	 "top", XawChainTop,
	 "right", XawChainRight,
	 NULL);
	 /*
    f2 = XtVaCreateManagedWidget("form2", formWidgetClass, f0,
         "fromVert", f1,
	 "top", XawChainTop,
	 "left", XawChainLeft,
	 "resizable", True,
	 NULL);
	 */
    e1 = XtVaCreateManagedWidget("edit", asciiTextWidgetClass, f0,
         "type", XawAsciiFile, "string", ConfigFile, 
	 "width", 400, "height", 250,
	 "resize", XawtextResizeBoth,
	 "editType", XawtextEdit,
	 "displayCaret", True,
	 "fromVert", f1,
	 "top", XawChainTop,
	 "bottom", XawChainBottom,
	 "left", XawChainLeft,
	 "right", XawChainRight,
	 NULL);
    f3 = XtVaCreateManagedWidget("form3", formWidgetClass, f0,
         "fromVert", e1,
	 "borderWidth", 0,
	 "resizable", True,
	 "x", 300,
	 "top", XawChainBottom,
	 "left", XawChainLeft,
	 "right", XawChainRight,
	 NULL);
    b1 = XtVaCreateManagedWidget("Save", commandWidgetClass, f3,
         XtNlabel, "Save", 
	 "fromHoriz", NULL,
	 NULL);
    b2 = XtVaCreateManagedWidget("Cancel", commandWidgetClass, f3,
         XtNlabel, "Cancel", 
	 "fromHoriz", b1, NULL);
    s = XtVaCreateManagedWidget("Status", labelWidgetClass, f0,
         XtNlabel, ". . .", 
	 "borderWidth", 0, "width", 400,
	 "fromVert", f3,
	 "resizable", True,
	 "top", XawChainBottom,
	 NULL);
    XtRealizeWidget (propsWin);
    XtMapWidget(propsWin);

    //l3 =  asciiTextWidgetClass
    //e2 = XtVaCreateManaged("label2",
    //f1 = XtVaCreateManagedWidget("form2", formWidgetClass, propsWin,
    XtAddCallback (b2, XtNcallback, procCancel, NULL);
    XtVaGetValues(e1, "textSource", &textSrc);
    XtAddCallback (b1, XtNcallback, procSave, client_data);
    //if(!wm_delete_window)
    wm_delete_window = XInternAtom (XtDisplay(propsWin), 
                       "WM_DELETE_WINDOW",False);
    (void) XSetWMProtocols (XtDisplay(propsWin), XtWindow(propsWin),
                          &wm_delete_window, 1);
}

